// Copyright (C) 1999 Jean-Marc Valin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef CONCATENATE_H
#define CONCATENATE_H

#include "Node.h"
#include "FrameBinaryOperation.h"

/**A FrameBinaryOperation that takes functions directly from a shared library*/
class Concatenate : public FrameBinaryOperation {
public:

   /**Constructor, takes the name of the node and a set of parameters*/
   Concatenate(string nodeName, ParameterSet params);

   /**Destructor*/
   ~Concatenate();

   /**Class specific initialization routine.
      Each class will call its subclass specificInitialize() method*/
   virtual void specificInitialize();

   /**Class reset routine.
      Each class will call its superclass reset() method*/
   virtual void reset();

protected:

   /**Default constructor, should not be used*/
   Concatenate() 
   {throw new GeneralException("Concatenate copy constructor should not be called",__FILE__,__LINE__);}

   /**Computes the output for one frame*/
   virtual void computeFrame(ObjectRef input1, ObjectRef input2, int count);

};

#endif
