#ifndef UITERMINAL_H
#define UITERMINAL_H

//#include <gnome.h>
#include <vector>
#include <string>
#include <fstream.h>

class UINode;
class UILink;
class UINetTerminal;

class UITerminal {
protected:

   /**The terminal name*/
   string name;

   /**The node that owns this terminal*/
   UINode *node;

   /**position relative to node group*/
   double x,y;

   /**Whether it's an input of the node (otherwise, output)*/
   bool isInput;

   /**All connected links (only one allowed for inputs)*/
   vector <UILink *> connections;

   /**The net input/output connected to the terminal (NULL if none)*/
   UINetTerminal *netTerminal;

public:
   UITerminal (string _name, UINode *_node, bool _isInput, double _x, double _y);

   virtual ~UITerminal();


   UINode *getNode() {return node;}


   /**returns the position in world coord*/
   virtual void getPos(double &wx, double &wy)
   {
      wx=x;
      wy=y;
      //gnome_canvas_item_i2w(item->parent, &wx, &wy);
   }

   /**returns the position in item coord*/
   void getItemPos(double &wx, double &wy)
   {
      wx=x;
      wy=y;
   }

   /**connect to a link*/
   void connect(UILink *link) {connections.insert(connections.end(), link);}
   
   /**disconnect from a link*/
   void disconnect(UILink *link) 
   {
      for (int i=0;i<connections.size();i++)
         if (connections[i]==link)
            connections.erase(&connections[i]);
   }

   /**connect to a network terminal*/
   void connectNetTerminal(UINetTerminal *term) {netTerminal = term;}

   /**connect to a network terminal*/
   void disconnectNetTerminal() {netTerminal = NULL;}

   const string &getName() {return name;}
   
   bool isConnected() {return connections.size()!=0 || netTerminal;}
   
   void export2net (ostream &out);

};

#endif
